package cologne.eck.image_pea;


/*
 * Peafactory - Production of Password Encryption Archives
 * Copyright (C) 2020  Axel von dem Bruch
 * 
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, 
 * or (at your option) any later version.
 * This library is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 * See:  http://www.gnu.org/licenses/gpl-2.0.html
 * You should have received a copy of the GNU General Public License 
 * along with this library.
 */

/*
import java.util.ArrayList;
import java.util.HashSet;
*/
/*
import cologne.eck.all_peas.data.PeaProperties;
import cologne.eck.tools.TestLog;
import cologne.eck.tools.UnexpectedValueException;
*/

/*
 * Model for Images: 
 * Files with the same file name and content are grouped into sets
 * along with the last used IV.
 * The IV for one version of the file is always the same. 
 * For later use:
 * If the content is changed, all files in the set are updated.
 */

class ImageModel {
	/**
	 * List of sets of
	 * associated file names with path, where changes are to be stored
	 */
//	private static ArrayList< HashSet<String>> setList = new ArrayList<HashSet<String>>();

	/**
	 * Add a set to the list of associated file names with path. 
	 * This method checks if the file is already open. 
	 * 
	 * @param set		the set of file names with path
	 * 
	 * @return	null for success, a localized error message if already open.
	 */
/*	protected static String addFileNameSet(HashSet<String> set) {
		
		for(HashSet<String> setInList : setList) {
			for (String s : set) {
				if (setInList.contains(s)) {
					TestLog.e(ImageModel.class, "File name was already listed: " + s);
					new UnexpectedValueException("String", "s", "already listed in set").printDescription();
					return PeaProperties.getVmBridge().translate("file_already_open");
				}
			}
		}
		setList.add(set);
		return null;
	}*/
	/**
	 * Add a file name to an existing set.
	 * 
	 * @param fileNameWithPath	the new file name with absolute path to add
	 * @param fileNameInSet		one file name with path in the existing set
	 * 
	 * @return	true if added, false if no such set exists
	 */
/*	protected static boolean addFileNameToSet(String newFileNameWithPath, String fileNameInSet) {
		// search the set:
		HashSet<String> set = null;
		for (HashSet<String> foundSet : setList) {
			if (foundSet.contains(newFileNameWithPath)) {
				set = foundSet;
			}
		}
		if (set == null) {
			TestLog.v(ImageModel.class, "No set found with file " + fileNameInSet 
					+ " to add " + newFileNameWithPath);
			return false;
		} else {
			set.add(newFileNameWithPath);
			return true;
		}
	}*/
	
	/**
	 * Get all sets of file names with path as list.
	 * 
	 * @return	a list of sets of file names with path
	 */
/*	protected static ArrayList<HashSet<String>> getSetList() {
		return setList;
	}*/
	
	/**
	 * Get the set of associated file names with path for a
	 * file name with path
	 * 
	 * @param fileNameWithPath	the file name with absolute path
	 * 
	 * @return	the set of file names associated with this file name or null
	 * 			if no such set exists
	 */
/*	protected static HashSet<String> getFileNameSet(String fileNameWithPath) {
		for (HashSet<String> setInList : setList) {
			if (setInList.contains(fileNameWithPath)) {
				return setInList;
			}
		}
		return null;//tabMap.get(fileNameWithoutPath);
	}*/
	
	/**
	 * Set the map of file names as keys and the set of
	 * associated file names with path
	 * 
	 * @param newMap	the map (file name = key, set of associated = value)
	 */
	//public static void setMapXXX(HashMap<String, HashSet<String>> newMap) {
	//	tabMap = newMap;
	//}
	/**
	 * Remove one set from the list
	 * 
	 * @param fileName	one file name of the set to remove
	 * 
	 * @return	true if set was removed, false if set does not exist
	 */
/*	protected static boolean removeFromMap(String fileNameWithPath) {
		for (HashSet<String> setInList : setList) {
			if (setInList.contains(fileNameWithPath)) {
				return setList.remove( setInList );
			}
		}
		return false;//tabMap.get(fileNameWithoutPath);
		//return tabMap.remove(fileName);
	}*/
	/**
	 * Checks if a file name is already listed in one of the sets
	 * 
	 * @param fileNameWithPath	the file name to check
	 * 
	 * @return	true if the file name is already listed
	 */
/*	protected static boolean fileNameExists(String fileNameWithPath) {
		for (HashSet<String> setInList : setList) {
			if (setInList.contains(fileNameWithPath)) {
				return true;
			}
		}
		return false;
	}*/
}
